"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDom = require("react-dom");
var _redux = require("redux");
var _reactRedux = require("react-redux");
var _moduleRegistry = _interopRequireDefault(require("../module-registry"));
var _EventListener = require("./EventListener");
var _reactRouter = require("react-router");
var _demo = _interopRequireDefault(require("./demo.scss"));
var store = (0, _redux.createStore)(function (state, action) {
  if (state === void 0) {
    state = 'react-input-value';
  }
  return action.type === 'assign' ? action.value : state;
});
var withStore = (0, _reactRedux.connect)(function (state) {
  return {
    value: state
  };
}, function (dispatch) {
  return {
    assign: function assign(value) {
      return dispatch({
        type: 'assign',
        value: value
      });
    }
  };
});
var topology = {
  staticsUrl: 'http://localhost:3200/lazy/',
  baseUrl: 'http://localhost:3200/'
};
var rootElement = document.getElementById('root');
var MyApp = {
  MyNgComp: _moduleRegistry["default"].component('MyApp.MyNgComp')
};
var MyApp2 = {
  MyNgComp: _moduleRegistry["default"].component('MyApp2.MyNgComp')
};
var MyApp3 = {
  MyReactComp: _moduleRegistry["default"].component('MyApp3.MyReactComp')
};
var MyApp4 = {
  MyNgComp: _moduleRegistry["default"].component('MyApp4.MyNgComp')
};
var MyApp5 = {
  MyNgComp: _moduleRegistry["default"].component('MyApp5.MyNgComp')
};
var MyApp5NoUnloadCss = {
  MyNgComp: _moduleRegistry["default"].component('MyApp5NoUnloadCss.MyNgComp')
};
var MyApp6 = {
  MyReactCompCrossOrigin: _moduleRegistry["default"].component('MyApp6.MyReactCompCrossOrigin')
};
var MyApp7 = {
  MyReactComp: _moduleRegistry["default"].component('MyApp7.MyReactComp')
};
var MyApp8 = {
  MyReactComp: _moduleRegistry["default"].component('MyApp8.MyReactComp')
};
var SplatLink = (0, _reactRouter.withRouter)(function (props) {
  var newProps = {
    to: props.to,
    className: props.className,
    style: props.style
  };
  if (props.location.pathname.indexOf(props.to) === 0) {
    newProps.style = (0, _extends2["default"])({}, props.style, props.activeStyle);
    newProps.className = (props.className || '') + " " + (props.activeClassName || '');
  }
  return /*#__PURE__*/_react["default"].createElement(_reactRouter.Link, newProps, props.children);
});
var Navigation = withStore(function (props) {
  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_EventListener.EventsListener, null), /*#__PURE__*/_react["default"].createElement("input", {
    id: "react-input",
    value: props.value,
    onChange: function onChange(e) {
      return props.assign(e.target.value);
    }
  }), /*#__PURE__*/_react["default"].createElement("br", null), /*#__PURE__*/_react["default"].createElement(SplatLink, (0, _extends2["default"])({}, props, {
    to: "/ng-router-app/a",
    activeClassName: _demo["default"].activeLink,
    className: "nav"
  }), "ng-router-app"), "\xA0", /*#__PURE__*/_react["default"].createElement(SplatLink, (0, _extends2["default"])({}, props, {
    to: "/ui-router-app/",
    activeClassName: _demo["default"].activeLink,
    className: "nav"
  }), "ui-router-app"), "\xA0", /*#__PURE__*/_react["default"].createElement(SplatLink, (0, _extends2["default"])({}, props, {
    to: "/rt-router-app/",
    activeClassName: _demo["default"].activeLink,
    className: "nav"
  }), "rt-router-app"), "\xA0", /*#__PURE__*/_react["default"].createElement(SplatLink, (0, _extends2["default"])({}, props, {
    to: "/ng-router-app/b",
    activeClassName: _demo["default"].activeLink,
    className: "nav"
  }), "ng-router-app"), "\xA0", /*#__PURE__*/_react["default"].createElement(SplatLink, (0, _extends2["default"])({}, props, {
    to: "/ng-router-app4",
    activeClassName: _demo["default"].activeLink,
    className: "nav"
  }), "ng-router-app4"), "\xA0", /*#__PURE__*/_react["default"].createElement(SplatLink, (0, _extends2["default"])({}, props, {
    to: "/ng-router-app5",
    activeClassName: _demo["default"].activeLink,
    className: "nav"
  }), "ng-router-app5"), "\xA0", /*#__PURE__*/_react["default"].createElement(SplatLink, (0, _extends2["default"])({}, props, {
    to: "/ng-router-app5-no-unload-css",
    activeClassName: _demo["default"].activeLink,
    className: "nav"
  }), "ng-router-app5-no-unload-css"), "\xA0", /*#__PURE__*/_react["default"].createElement(SplatLink, (0, _extends2["default"])({}, props, {
    to: "/rt-router-app6",
    activeClassName: _demo["default"].activeLink,
    className: "nav"
  }), "rt-router-app6"), "\xA0", /*#__PURE__*/_react["default"].createElement(SplatLink, (0, _extends2["default"])({}, props, {
    to: "/rt-router-app7",
    activeClassName: _demo["default"].activeLink,
    className: "nav"
  }), "rt-router-app7"), "\xA0", /*#__PURE__*/_react["default"].createElement(SplatLink, (0, _extends2["default"])({}, props, {
    to: "/rt-router-app8",
    activeClassName: _demo["default"].activeLink,
    className: "nav"
  }), "rt-router-app8"), "\xA0", /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      marginTop: '15px'
    }
  }, props.children));
});
Navigation.propTypes = {
  children: _propTypes["default"].any
};
var Home = function Home() {
  return /*#__PURE__*/_react["default"].createElement("span", {
    id: "hello"
  }, "hello");
};
var App = withStore((0, _reactRouter.withRouter)(function (props) {
  return /*#__PURE__*/_react["default"].createElement(MyApp.MyNgComp, (0, _extends2["default"])({
    topology: topology
  }, props));
}));
var App2 = withStore((0, _reactRouter.withRouter)(function (props) {
  return /*#__PURE__*/_react["default"].createElement(MyApp2.MyNgComp, (0, _extends2["default"])({
    topology: topology
  }, props));
}));
var App3 = withStore((0, _reactRouter.withRouter)(function (props) {
  return /*#__PURE__*/_react["default"].createElement(MyApp3.MyReactComp, (0, _extends2["default"])({
    topology: topology
  }, props));
}));
var App4 = withStore((0, _reactRouter.withRouter)(function (props) {
  return /*#__PURE__*/_react["default"].createElement(MyApp4.MyNgComp, (0, _extends2["default"])({
    topology: topology
  }, props));
}));
var App5 = withStore((0, _reactRouter.withRouter)(function (props) {
  return /*#__PURE__*/_react["default"].createElement(MyApp5.MyNgComp, (0, _extends2["default"])({
    topology: topology
  }, props));
}));
var App5NoUnloadModule = withStore((0, _reactRouter.withRouter)(function (props) {
  return /*#__PURE__*/_react["default"].createElement(MyApp5NoUnloadCss.MyNgComp, (0, _extends2["default"])({
    topology: topology
  }, props));
}));
var App6 = withStore((0, _reactRouter.withRouter)(function (props) {
  return /*#__PURE__*/_react["default"].createElement(MyApp6.MyReactCompCrossOrigin, (0, _extends2["default"])({
    topology: topology
  }, props));
}));
var App7 = withStore((0, _reactRouter.withRouter)(function (props) {
  return /*#__PURE__*/_react["default"].createElement(MyApp7.MyReactComp, (0, _extends2["default"])({
    topology: topology
  }, props));
}));
var App8 = withStore((0, _reactRouter.withRouter)(function (props) {
  return /*#__PURE__*/_react["default"].createElement(MyApp8.MyReactComp, (0, _extends2["default"])({
    topology: topology
  }, props));
}));
(0, _reactDom.render)( /*#__PURE__*/_react["default"].createElement(_reactRedux.Provider, {
  store: store
}, /*#__PURE__*/_react["default"].createElement(_reactRouter.Router, {
  history: _reactRouter.browserHistory
}, /*#__PURE__*/_react["default"].createElement(_reactRouter.Route, {
  path: "/",
  component: Navigation
}, /*#__PURE__*/_react["default"].createElement(_reactRouter.IndexRoute, {
  component: Home
}), /*#__PURE__*/_react["default"].createElement(_reactRouter.Route, {
  path: "/ng-router-app/**",
  component: App
}), /*#__PURE__*/_react["default"].createElement(_reactRouter.Route, {
  path: "/ui-router-app/**",
  component: App2
}), /*#__PURE__*/_react["default"].createElement(_reactRouter.Route, {
  path: "/rt-router-app/**",
  component: App3
}), /*#__PURE__*/_react["default"].createElement(_reactRouter.Route, {
  path: "/ng-router-app4",
  component: App4
}), /*#__PURE__*/_react["default"].createElement(_reactRouter.Route, {
  path: "/ng-router-app5",
  component: App5
}), /*#__PURE__*/_react["default"].createElement(_reactRouter.Route, {
  path: "/ng-router-app5-no-unload-css",
  component: App5NoUnloadModule
}), /*#__PURE__*/_react["default"].createElement(_reactRouter.Route, {
  path: "/rt-router-app6",
  component: App6
}), /*#__PURE__*/_react["default"].createElement(_reactRouter.Route, {
  path: "/rt-router-app7",
  component: App7
}), /*#__PURE__*/_react["default"].createElement(_reactRouter.Route, {
  path: "/rt-router-app8",
  component: App8
})))), rootElement);