"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _fakeServer = _interopRequireDefault(require("../mock/fake-server"));
var getText = function getText(selector) {
  return page.$eval(selector, function (node) {
    return node.textContent;
  });
};
var select = function select(selector) {
  return page.$(selector);
};
var click = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(selector) {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return select(selector);
        case 2:
          return _context.abrupt("return", _context.sent.click());
        case 3:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function click(_x) {
    return _ref.apply(this, arguments);
  };
}();
var type = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(selector, text) {
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          _context2.next = 2;
          return select(selector);
        case 2:
          return _context2.abrupt("return", _context2.sent.type(text));
        case 3:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
  return function type(_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}();
var getNavBackgroundColor = function getNavBackgroundColor(index) {
  return page.$$eval('.nav', function (nodes, i) {
    return getComputedStyle(nodes[i]).backgroundColor;
  }, index);
};
var clickOnNav = /*#__PURE__*/function () {
  var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(index) {
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          _context3.next = 2;
          return page.$$('.nav');
        case 2:
          _context3.t0 = index;
          return _context3.abrupt("return", _context3.sent[_context3.t0].click());
        case 4:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return function clickOnNav(_x4) {
    return _ref3.apply(this, arguments);
  };
}();
var getComputedStyle = function getComputedStyle(selector, property) {
  return page.$eval(selector, function (node, prop) {
    return getComputedStyle(node)[prop];
  }, property);
};
describe('React application', function () {
  beforeAll(function () {
    _fakeServer["default"].start();
  });
  afterAll(function () {
    _fakeServer["default"].stop();
  });
  describe('life cycle events', function () {
    it('should not have navigation events', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return page["goto"](_fakeServer["default"].getUrl('/'));
          case 2:
            _context4.t0 = expect;
            _context4.next = 5;
            return getText('#got-start-loading');
          case 5:
            _context4.t1 = _context4.sent;
            (0, _context4.t0)(_context4.t1).toBe('false');
            _context4.t2 = expect;
            _context4.next = 10;
            return getText('#got-component-ready');
          case 10:
            _context4.t3 = _context4.sent;
            (0, _context4.t2)(_context4.t3).toBe('false');
            _context4.t4 = expect;
            _context4.next = 15;
            return getText('#got-component-will-unmount');
          case 15:
            _context4.t5 = _context4.sent;
            (0, _context4.t4)(_context4.t5).toBe('false');
          case 17:
          case "end":
            return _context4.stop();
        }
      }, _callee4);
    })));
    it('should have navigation events', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
      return _regenerator["default"].wrap(function _callee5$(_context5) {
        while (1) switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return page["goto"](_fakeServer["default"].getUrl('/ng-router-app4'));
          case 2:
            _context5.t0 = expect;
            _context5.next = 5;
            return getText('#got-start-loading');
          case 5:
            _context5.t1 = _context5.sent;
            (0, _context5.t0)(_context5.t1).toBe('true');
            _context5.t2 = expect;
            _context5.next = 10;
            return getText('#got-component-ready');
          case 10:
            _context5.t3 = _context5.sent;
            (0, _context5.t2)(_context5.t3).toBe('true');
            _context5.t4 = expect;
            _context5.next = 15;
            return getText('#got-component-will-unmount');
          case 15:
            _context5.t5 = _context5.sent;
            (0, _context5.t4)(_context5.t5).toBe('false');
            _context5.next = 19;
            return clickOnNav(5);
          case 19:
            _context5.t6 = expect;
            _context5.next = 22;
            return getText('#got-component-will-unmount');
          case 22:
            _context5.t7 = _context5.sent;
            (0, _context5.t6)(_context5.t7).toBe('true');
          case 24:
          case "end":
            return _context5.stop();
        }
      }, _callee5);
    })));
  });
  describe('open page', function () {
    it('should display hello', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
      return _regenerator["default"].wrap(function _callee6$(_context6) {
        while (1) switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return page["goto"](_fakeServer["default"].getUrl('/'));
          case 2:
            _context6.t0 = expect;
            _context6.next = 5;
            return getText('#hello');
          case 5:
            _context6.t1 = _context6.sent;
            (0, _context6.t0)(_context6.t1).toBe('hello');
          case 7:
          case "end":
            return _context6.stop();
        }
      }, _callee6);
    })));
    ['ng', 'ui'].forEach(function (router, index) {
      return describe("/" + router + "-router-app/", function () {
        it("should display " + router + " router app", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7() {
          return _regenerator["default"].wrap(function _callee7$(_context7) {
            while (1) switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return page["goto"](_fakeServer["default"].getUrl("/" + router + "-router-app/"));
              case 2:
                _context7.t0 = expect;
                _context7.next = 5;
                return getText('#value-in-angular');
              case 5:
                _context7.t1 = _context7.sent;
                (0, _context7.t0)(_context7.t1).toBe('react-input-value');
                _context7.t2 = expect;
                _context7.next = 10;
                return getText(router + "-view");
              case 10:
                _context7.t3 = _context7.sent;
                (0, _context7.t2)(_context7.t3).toBe('BAZINGA!');
                _context7.t4 = expect;
                _context7.next = 15;
                return getText('#value-in-react');
              case 15:
                _context7.t5 = _context7.sent;
                (0, _context7.t4)(_context7.t5).toBe('angular-input-value');
                _context7.t6 = expect;
                _context7.next = 20;
                return getText('#counter');
              case 20:
                _context7.t7 = _context7.sent;
                (0, _context7.t6)(_context7.t7).toBe('0');
              case 22:
              case "end":
                return _context7.stop();
            }
          }, _callee7);
        })));
        it('should update inputs in nested apps', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8() {
          return _regenerator["default"].wrap(function _callee8$(_context8) {
            while (1) switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return page["goto"](_fakeServer["default"].getUrl("/" + router + "-router-app/"));
              case 2:
                _context8.next = 4;
                return click('#counter');
              case 4:
                _context8.next = 6;
                return type('#angular-input', '123');
              case 6:
                _context8.next = 8;
                return type('#react-input', '123');
              case 8:
                _context8.t0 = expect;
                _context8.next = 11;
                return getText('#value-in-angular');
              case 11:
                _context8.t1 = _context8.sent;
                (0, _context8.t0)(_context8.t1).toBe('react-input-value123');
                _context8.t2 = expect;
                _context8.next = 16;
                return getText('#value-in-react');
              case 16:
                _context8.t3 = _context8.sent;
                (0, _context8.t2)(_context8.t3).toBe('angular-input-value123');
                _context8.t4 = expect;
                _context8.next = 21;
                return getText('#counter');
              case 21:
                _context8.t5 = _context8.sent;
                (0, _context8.t4)(_context8.t5).toBe('1');
              case 23:
              case "end":
                return _context8.stop();
            }
          }, _callee8);
        })));
        it('should support internal navigations', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9() {
          return _regenerator["default"].wrap(function _callee9$(_context9) {
            while (1) switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return page["goto"](_fakeServer["default"].getUrl("/" + router + "-router-app/"));
              case 2:
                _context9.next = 4;
                return click('#counter');
              case 4:
                _context9.next = 6;
                return type('#angular-input', '123');
              case 6:
                _context9.next = 8;
                return type('#react-input', '123');
              case 8:
                _context9.next = 10;
                return click('#stagadish');
              case 10:
                _context9.t0 = expect;
                _context9.next = 13;
                return getNavBackgroundColor(router === 'ng' ? 3 : 1);
              case 13:
                _context9.t1 = _context9.sent;
                (0, _context9.t0)(_context9.t1).toBe('rgb(255, 255, 0)');
                _context9.t2 = expect;
                _context9.next = 18;
                return getText('#value-in-angular');
              case 18:
                _context9.t3 = _context9.sent;
                (0, _context9.t2)(_context9.t3).toBe('react-input-value123');
                _context9.t4 = expect;
                _context9.next = 23;
                return getText('#value-in-react');
              case 23:
                _context9.t5 = _context9.sent;
                (0, _context9.t4)(_context9.t5).toBe('angular-input-value123');
                _context9.t6 = expect;
                _context9.next = 28;
                return getText('#counter');
              case 28:
                _context9.t7 = _context9.sent;
                (0, _context9.t6)(_context9.t7).toBe('1');
                _context9.t8 = expect;
                _context9.next = 33;
                return getText(router + "-view");
              case 33:
                _context9.t9 = _context9.sent;
                (0, _context9.t8)(_context9.t9).toBe('STAGADISH!');
              case 35:
              case "end":
                return _context9.stop();
            }
          }, _callee9);
        })));
        it('should be able to navigate from within nested app', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10() {
          return _regenerator["default"].wrap(function _callee10$(_context10) {
            while (1) switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return page["goto"](_fakeServer["default"].getUrl("/" + router + "-router-app/a"));
              case 2:
                _context10.t0 = expect;
                _context10.next = 5;
                return getNavBackgroundColor(index);
              case 5:
                _context10.t1 = _context10.sent;
                (0, _context10.t0)(_context10.t1).toBe('rgb(255, 255, 0)');
                _context10.next = 9;
                return click('#react-app-link');
              case 9:
                _context10.t2 = expect;
                _context10.next = 12;
                return getNavBackgroundColor(2);
              case 12:
                _context10.t3 = _context10.sent;
                (0, _context10.t2)(_context10.t3).toBe('rgb(255, 255, 0)');
                _context10.next = 16;
                return page.waitForSelector('.react-link');
              case 16:
                _context10.next = 18;
                return page.$$('.react-link');
              case 18:
                _context10.t4 = index;
                _context10.next = 21;
                return _context10.sent[_context10.t4].click();
              case 21:
                _context10.t5 = expect;
                _context10.next = 24;
                return getNavBackgroundColor(index);
              case 24:
                _context10.t6 = _context10.sent;
                (0, _context10.t5)(_context10.t6).toBe('rgb(255, 255, 0)');
              case 26:
              case "end":
                return _context10.stop();
            }
          }, _callee10);
        })));
        it('should be able to navigate from react embedded in angular', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11() {
          return _regenerator["default"].wrap(function _callee11$(_context11) {
            while (1) switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return page["goto"](_fakeServer["default"].getUrl("/" + router + "-router-app/"));
              case 2:
                _context11.next = 4;
                return type('#react-input', '123');
              case 4:
                _context11.next = 6;
                return page.$$('.react-link');
              case 6:
                _context11.t0 = index ? 0 : 1;
                _context11.next = 9;
                return _context11.sent[_context11.t0].click();
              case 9:
                _context11.t1 = expect;
                _context11.next = 12;
                return getNavBackgroundColor(index ? 0 : 1);
              case 12:
                _context11.t2 = _context11.sent;
                (0, _context11.t1)(_context11.t2).toBe('rgb(255, 255, 0)');
                _context11.t3 = expect;
                _context11.next = 17;
                return getText('#value-in-angular');
              case 17:
                _context11.t4 = _context11.sent;
                (0, _context11.t3)(_context11.t4).toBe('react-input-value123');
              case 19:
              case "end":
                return _context11.stop();
            }
          }, _callee11);
        })));
      });
    });
  });
  describe('manifest with resolve', function () {
    ['ui', 'rt'].forEach(function (router) {
      return describe("/" + router + "-router-app/", function () {
        it("should display the resolved data", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12() {
          return _regenerator["default"].wrap(function _callee12$(_context12) {
            while (1) switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return page["goto"](_fakeServer["default"].getUrl("/" + router + "-router-app/"));
              case 2:
                _context12.t0 = expect;
                _context12.next = 5;
                return getText('#value-of-resolved-experiments');
              case 5:
                _context12.t1 = _context12.sent;
                (0, _context12.t0)(_context12.t1).toBe(JSON.stringify({
                  'specs.fed.ReactModuleContainerWithResolve': true
                }));
                _context12.t2 = expect;
                _context12.next = 10;
                return getText('#value-of-resolved-custom-data');
              case 10:
                _context12.t3 = _context12.sent;
                (0, _context12.t2)(_context12.t3).toBe(JSON.stringify({
                  user: 'xiw@wix.com'
                }));
              case 12:
              case "end":
                return _context12.stop();
            }
          }, _callee12);
        })));
      });
    });
  });
  describe('manifest with prepare', function () {
    ['ui', 'rt'].forEach(function (router) {
      return describe("/" + router + "-router-app/", function () {
        it("should call prepare", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13() {
          return _regenerator["default"].wrap(function _callee13$(_context13) {
            while (1) switch (_context13.prev = _context13.next) {
              case 0:
                _context13.next = 2;
                return page["goto"](_fakeServer["default"].getUrl("/" + router + "-router-app/"));
              case 2:
                _context13.t0 = expect;
                _context13.next = 5;
                return page.evaluate(function () {
                  return window.__prepare_was_called__;
                });
              case 5:
                _context13.t1 = _context13.sent;
                (0, _context13.t0)(_context13.t1).toBe(true);
              case 7:
              case "end":
                return _context13.stop();
            }
          }, _callee13);
        })));
      });
    });
  });
  describe('manifest with crossorigin', function () {
    it("should load the component with the crossorigin attribute", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14() {
      var lazyComponentScriptsWithCrossOrigin;
      return _regenerator["default"].wrap(function _callee14$(_context14) {
        while (1) switch (_context14.prev = _context14.next) {
          case 0:
            _context14.next = 2;
            return page["goto"](_fakeServer["default"].getUrl("/rt-router-app6/"));
          case 2:
            _context14.next = 4;
            return page.$$eval('script', function (scripts) {
              return scripts.filter(function (element) {
                return element.getAttribute('src').endsWith('react-module.bundle.js');
              }).filter(function (element) {
                return element.getAttribute('crossorigin') !== null;
              });
            });
          case 4:
            lazyComponentScriptsWithCrossOrigin = _context14.sent;
            expect(lazyComponentScriptsWithCrossOrigin).toHaveLength(1);
          case 6:
          case "end":
            return _context14.stop();
        }
      }, _callee14);
    })));
  });
  describe('unload styles on destroy', function () {
    var linksToModuleWithUnloadCss = {
      notDefined: 4,
      "true": 5,
      "false": 6
    };
    var linksToReactModuleWithUnloadCss = {
      notDefined: 8,
      "false": 9
    };
    beforeEach( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15() {
      return _regenerator["default"].wrap(function _callee15$(_context15) {
        while (1) switch (_context15.prev = _context15.next) {
          case 0:
            _context15.next = 2;
            return page["goto"](_fakeServer["default"].getUrl('/'));
          case 2:
          case "end":
            return _context15.stop();
        }
      }, _callee15);
    })));
    it('should by default unload css files specified inside angular manifest', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee16() {
      return _regenerator["default"].wrap(function _callee16$(_context16) {
        while (1) switch (_context16.prev = _context16.next) {
          case 0:
            _context16.next = 2;
            return clickOnNav(linksToModuleWithUnloadCss.notDefined);
          case 2:
            _context16.t0 = expect;
            _context16.next = 5;
            return getStyleSheetHrefs();
          case 5:
            _context16.t1 = _context16.sent;
            (0, _context16.t0)(_context16.t1).toEqual(['http://localhost:3200/demo.css', 'http://localhost:3200/demo-shared.css', 'http://localhost:3200/demo-4.css']);
            _context16.next = 9;
            return expectIsHidden('.demo-5');
          case 9:
            _context16.next = 11;
            return clickOnNav(linksToModuleWithUnloadCss["false"]);
          case 11:
            _context16.t2 = expect;
            _context16.next = 14;
            return getStyleSheetHrefs();
          case 14:
            _context16.t3 = _context16.sent;
            (0, _context16.t2)(_context16.t3).toEqual(['http://localhost:3200/demo.css', 'http://localhost:3200/demo-shared.css', 'http://localhost:3200/demo-5.css']);
          case 16:
          case "end":
            return _context16.stop();
        }
      }, _callee16);
    })));
    it('should not unload css files specified inside angular manifest', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee17() {
      return _regenerator["default"].wrap(function _callee17$(_context17) {
        while (1) switch (_context17.prev = _context17.next) {
          case 0:
            _context17.next = 2;
            return clickOnNav(linksToModuleWithUnloadCss["false"]);
          case 2:
            _context17.t0 = expect;
            _context17.next = 5;
            return getStyleSheetHrefs();
          case 5:
            _context17.t1 = _context17.sent;
            (0, _context17.t0)(_context17.t1).toEqual(['http://localhost:3200/demo.css', 'http://localhost:3200/demo-shared.css', 'http://localhost:3200/demo-5.css']);
            _context17.next = 9;
            return expectIsHidden('.demo-4');
          case 9:
            _context17.next = 11;
            return clickOnNav(linksToModuleWithUnloadCss.notDefined);
          case 11:
            _context17.t2 = expect;
            _context17.next = 14;
            return getStyleSheetHrefs();
          case 14:
            _context17.t3 = _context17.sent;
            (0, _context17.t2)(_context17.t3).toEqual(['http://localhost:3200/demo.css', 'http://localhost:3200/demo-shared.css', 'http://localhost:3200/demo-5.css', 'http://localhost:3200/demo-shared.css', 'http://localhost:3200/demo-4.css']);
          case 16:
          case "end":
            return _context17.stop();
        }
      }, _callee17);
    })));
    it('should unload css files specified inside angular manifest', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee18() {
      return _regenerator["default"].wrap(function _callee18$(_context18) {
        while (1) switch (_context18.prev = _context18.next) {
          case 0:
            _context18.next = 2;
            return clickOnNav(linksToModuleWithUnloadCss["true"]);
          case 2:
            _context18.t0 = expect;
            _context18.next = 5;
            return getStyleSheetHrefs();
          case 5:
            _context18.t1 = _context18.sent;
            (0, _context18.t0)(_context18.t1).toEqual(['http://localhost:3200/demo.css', 'http://localhost:3200/demo-shared.css', 'http://localhost:3200/demo-5.css']);
            _context18.t2 = expect;
            _context18.next = 10;
            return getComputedStyle('.demo-shared', 'backgroundColor');
          case 10:
            _context18.t3 = _context18.sent;
            (0, _context18.t2)(_context18.t3).toBe('rgb(200, 200, 200)');
            _context18.t4 = expect;
            _context18.next = 15;
            return getComputedStyle('.demo-5', 'color');
          case 15:
            _context18.t5 = _context18.sent;
            (0, _context18.t4)(_context18.t5).toBe('rgb(5, 5, 5)');
            _context18.next = 19;
            return expectIsHidden('.demo-4');
          case 19:
            _context18.next = 21;
            return clickOnNav(linksToModuleWithUnloadCss.notDefined);
          case 21:
            _context18.t6 = expect;
            _context18.next = 24;
            return getStyleSheetHrefs();
          case 24:
            _context18.t7 = _context18.sent;
            (0, _context18.t6)(_context18.t7).toEqual(['http://localhost:3200/demo.css', 'http://localhost:3200/demo-shared.css', 'http://localhost:3200/demo-4.css']);
            _context18.t8 = expect;
            _context18.next = 29;
            return getComputedStyle('.demo-shared', 'backgroundColor');
          case 29:
            _context18.t9 = _context18.sent;
            (0, _context18.t8)(_context18.t9).toBe('rgb(200, 200, 200)');
            _context18.t10 = expect;
            _context18.next = 34;
            return getComputedStyle('.demo-4', 'color');
          case 34:
            _context18.t11 = _context18.sent;
            (0, _context18.t10)(_context18.t11).toBe('rgb(4, 4, 4)');
          case 36:
          case "end":
            return _context18.stop();
        }
      }, _callee18);
    })));
    it('should unload css files specified inside react manifest', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee19() {
      return _regenerator["default"].wrap(function _callee19$(_context19) {
        while (1) switch (_context19.prev = _context19.next) {
          case 0:
            _context19.next = 2;
            return clickOnNav(linksToReactModuleWithUnloadCss.notDefined);
          case 2:
            _context19.next = 4;
            return clickOnNav(linksToModuleWithUnloadCss["false"]);
          case 4:
            _context19.t0 = expect;
            _context19.next = 7;
            return getStyleSheetHrefs();
          case 7:
            _context19.t1 = _context19.sent;
            (0, _context19.t0)(_context19.t1).toEqual(['http://localhost:3200/demo.css', 'http://localhost:3200/demo-shared.css', 'http://localhost:3200/demo-5.css']);
          case 9:
          case "end":
            return _context19.stop();
        }
      }, _callee19);
    })));
    it('should not unload css files specified inside react manifest', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee20() {
      return _regenerator["default"].wrap(function _callee20$(_context20) {
        while (1) switch (_context20.prev = _context20.next) {
          case 0:
            _context20.next = 2;
            return clickOnNav(linksToReactModuleWithUnloadCss["false"]);
          case 2:
            _context20.next = 4;
            return clickOnNav(linksToReactModuleWithUnloadCss.notDefined);
          case 4:
            _context20.t0 = expect;
            _context20.next = 7;
            return getStyleSheetHrefs();
          case 7:
            _context20.t1 = _context20.sent;
            (0, _context20.t0)(_context20.t1).toEqual(['http://localhost:3200/demo.css', 'http://localhost:3200/demo-shared.css', 'http://localhost:3200/demo-5.css', 'http://localhost:3200/demo-shared.css', 'http://localhost:3200/demo-4.css']);
          case 9:
          case "end":
            return _context20.stop();
        }
      }, _callee20);
    })));
    function getStyleSheetHrefs() {
      return page.$$eval('link', function (nodes) {
        return nodes.map(function (elem) {
          return elem.getAttribute('href');
        });
      });
    }
    function expectIsHidden(selector) {
      return page.waitForSelector(selector, {
        hidden: true
      });
    }
  });
});