"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _path = _interopRequireDefault(require("path"));
var _express = _interopRequireDefault(require("express"));
var _bodyParser = _interopRequireDefault(require("body-parser"));
var app = (0, _express["default"])();
app.use(_bodyParser["default"].json());
app.use(function (req, res, next) {
  res.setHeader('Cache-Control', 'no-cache, no-store, must-revalidate');
  res.setHeader('Pragma', 'no-cache');
  res.setHeader('Expires', 0);
  return next();
});
app.use('*', function (req, res) {
  res.sendFile(_path["default"].join(process.cwd(), './src/index.html'));
});
var port = process.env.PORT || 3000;
var server;
var _default = exports["default"] = {
  start: function start() {
    return new Promise(function (resolve) {
      server = app.listen(port, function () {
        console.log("Fake server is running on port " + port);
        resolve();
      });
    });
  },
  stop: function stop() {
    server && server.close();
  },
  getUrl: function getUrl(url) {
    return "http://localhost:" + port + url;
  }
};