"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _react = _interopRequireWildcard(require("react"));
var _chai = require("chai");
var _react2 = require("@testing-library/react");
var _src = require("../src");
var _sinon = _interopRequireDefault(require("sinon"));
var _SomeComponent = require("./mock/SomeComponent");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var hooks = {
  someComponent: 'some-component-root',
  loader: 'loader',
  subComponent: 'sub-component-root'
};
describe('ReactLoadableComponent', function () {
  afterEach(_react2.cleanup);
  afterEach(function () {
    return _sinon["default"].reset();
  });
  it('render the component', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var SomeComponent, _render, findByTestId, element;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          SomeComponent = (0, _src.ReactLoadableComponent)('SomeComponent', function () {
            return Promise.resolve().then(function () {
              return _interopRequireWildcard(require('./mock/SomeComponent'));
            });
          });
          _render = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(SomeComponent, null)), findByTestId = _render.findByTestId;
          _context.next = 4;
          return findByTestId(hooks.someComponent);
        case 4:
          element = _context.sent;
          (0, _chai.expect)(element.textContent).to.equal('Hello World!');
        case 6:
        case "end":
          return _context.stop();
      }
    }, _callee);
  })));
  describe('rendering with suspense support', function () {
    var resolver = _sinon["default"].fake( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return new Promise(function (resolve) {
              return setTimeout(resolve, 100);
            });
          case 2:
            return _context2.abrupt("return", Promise.resolve().then(function () {
              return _interopRequireWildcard(require('./mock/SomeComponent'));
            }));
          case 3:
          case "end":
            return _context2.stop();
        }
      }, _callee2);
    })));
    var renderResult, SomeComponent;
    beforeEach(function () {
      SomeComponent = (0, _src.ReactLoadableComponent)('SomeComponent', resolver);
      var wrapper = function wrapper(_ref3) {
        var children = _ref3.children;
        return /*#__PURE__*/_react["default"].createElement(_src.ReactModuleContainerContext.Provider, {
          value: {
            suspense: true
          }
        }, /*#__PURE__*/_react["default"].createElement(_react.Suspense, {
          fallback: /*#__PURE__*/_react["default"].createElement("div", {
            "data-hook": "loader"
          }, "Loading...")
        }, children));
      };
      renderResult = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(SomeComponent, null), {
        wrapper: wrapper
      });
    });
    it('should show a loader', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
      var loader;
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return renderResult.findByTestId(hooks.loader);
          case 2:
            loader = _context3.sent;
            (0, _chai.expect)(loader).to.exist;
          case 4:
          case "end":
            return _context3.stop();
        }
      }, _callee3);
    })));
    it('should handle rerenders', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
      var loader;
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return renderResult.findByTestId(hooks.loader);
          case 2:
            _context4.next = 4;
            return renderResult.rerender( /*#__PURE__*/_react["default"].createElement(SomeComponent, null));
          case 4:
            _context4.next = 6;
            return renderResult.findByTestId(hooks.loader);
          case 6:
            loader = _context4.sent;
            _context4.next = 9;
            return new Promise(function (resolve) {
              return setTimeout(resolve, 1000);
            });
          case 9:
            (0, _chai.expect)(loader).to.exist;
          case 10:
          case "end":
            return _context4.stop();
        }
      }, _callee4);
    })));
    describe('when loader is rendered', function () {
      beforeEach(function () {
        return renderResult.findByTestId(hooks.loader);
      });
      it('should not flicker when the internal component throws suspense', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
        var element;
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) switch (_context5.prev = _context5.next) {
            case 0:
              (0, _SomeComponent.throwPromiseOnNextRender)(); // A bit hacky, only works because component is imported and rendered async
              _context5.next = 3;
              return (0, _react2.waitForElementToBeRemoved)(function () {
                return renderResult.queryByTestId(hooks.loader);
              });
            case 3:
              element = renderResult.getByTestId(hooks.someComponent);
              (0, _chai.expect)(element).to.exist;
            case 5:
            case "end":
              return _context5.stop();
          }
        }, _callee5);
      })));
      it('should render the component after the loader is shown', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
        var element;
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) switch (_context6.prev = _context6.next) {
            case 0:
              _context6.next = 2;
              return renderResult.findByTestId(hooks.someComponent);
            case 2:
              element = _context6.sent;
              (0, _chai.expect)(element).to.exist;
            case 4:
            case "end":
              return _context6.stop();
          }
        }, _callee6);
      })));
      describe('when component is rendered', function () {
        beforeEach(function () {
          return renderResult.findByTestId(hooks.someComponent);
        });
        it('should call the resolver only once', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7() {
          return _regenerator["default"].wrap(function _callee7$(_context7) {
            while (1) switch (_context7.prev = _context7.next) {
              case 0:
                (0, _chai.expect)(resolver).to.be.calledOnce;
              case 1:
              case "end":
                return _context7.stop();
            }
          }, _callee7);
        })));
        it('should render the sub component without entering an infinite loop', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8() {
          var element;
          return _regenerator["default"].wrap(function _callee8$(_context8) {
            while (1) switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return renderResult.findByTestId(hooks.subComponent);
              case 2:
                element = _context8.sent;
                (0, _chai.expect)(element).to.exist;
              case 4:
              case "end":
                return _context8.stop();
            }
          }, _callee8);
        })));
      });
    });
  });
});